////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#include "cglstdafx.h"

#include "cglbutton.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CGLButton::CGLButton(GLfloat p_fx,GLfloat p_fy,
	GLfloat p_fWidth,GLfloat p_fHeight,
	const char * p_strText,	PFNONBUTTONPROC *p_pfnOnButton)
	:CGLLabel(p_fx,p_fy,p_fWidth,p_fHeight,p_strText)
{
	m_pfnOnButton=p_pfnOnButton;
}

void CGLButton::Draw(void)
{
	GLint nTextLength=m_strText.length();
	GLfloat fTextStartSM;
	if (CGL::GetLetterSize()*nTextLength<m_fWidth)
		fTextStartSM=m_fWidth/2-(nTextLength>>1)*CGL::GetLetterSize();
	else
		fTextStartSM=CGL::GetLetterSize();
	CGLControl::Draw();
	CGL::DrawText(m_fx+fTextStartSM,m_fy-m_fHeight/2+CGL::GetLetterSize()/2,m_fWidth,0.0,m_strText.c_str(),nTextLength);
}

void CGLButton::OnMouse(GLint p_nButton,GLint p_nState,GLfloat p_fx,GLfloat p_fy)
{
	if (p_nState==GLUT_DOWN)
	{
		if ((m_fx<=p_fx)&&(m_fy>=p_fy)&&(m_fx+m_fWidth>=p_fx)&&(m_fy-m_fHeight<=p_fy))
		{
			if (m_pfnOnButton) m_pfnOnButton();
		}
	}
}

void CGLButton::OnKeyboard(char p_chKey,GLint p_nx,GLint p_ny)
{
	switch (p_chKey)
	{
	//case '\n':
	case ' ':
		if (m_pfnOnButton) m_pfnOnButton();
		break;
	}
}
